<?php

class ConfigHolder
{
    public static $sections_lcfg = null;
    public static $cats_lcfg_map = null;

    ///////////////////////////////////////////////////////////////////////

    public static function initialize()
    {
        $from = SectionsHelper::get_sections_on_off_path();
        $to = self::sections_config_path();
        if (is_file($from) && !is_file($to))
        {
            // Upgrade from legacy 'on_off' file to standard lcfg.

            $doc = file_get_contents($from);
            HD::write_to_file_using_tmp($to, $doc);
        }
    }

    ///////////////////////////////////////////////////////////////////////

    public static function sections_config_id()
    {
        return MainHelper::$plugin_name . "_sections";
    }

    public static function sections_config_path()
    {
        return ListUtils::config_file_path(self::sections_config_id());
    }

    public static function sections_lcfg_reload() {
        self::$sections_lcfg = ListUtils::read_config_file(
            self::sections_config_id());
        return self::$sections_lcfg;
    }

    public static function sections_lcfg_ensure_loaded() {
        if (!self::$sections_lcfg)
            self::sections_lcfg_reload();
        return self::$sections_lcfg;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function cats_config_id($section_id)
    {
        return MainHelper::$plugin_name . "_${section_id}_categories";
    }

    public static function get_section_id_from_config_id($lcfg_id)
    {
        $off = strlen(MainHelper::$plugin_name . "_");
        $len = strlen($lcfg_id) - strlen("_categories") - $off;
        return substr($lcfg_id, $off, $len);
    }

    public static function cats_lcfg_reload($section_id)
    {
        if (isset(self::$cats_lcfg_map))
            self::$cats_lcfg_map = array();
        self::$cats_lcfg_map[$section_id] = ListUtils::read_config_file(
            self::cats_config_id($section_id));
        return self::$cats_lcfg_map[$section_id];
    }

    public static function cats_lcfg_ensure_loaded($section_id)
    {
        if (isset(self::$cats_lcfg_map))
            self::$cats_lcfg_map = array();
        if (!isset(self::$cats_lcfg_map[$section_id]))
            self::cats_lcfg_reload($section_id);
        return self::$cats_lcfg_map[$section_id];
    }
}

?>
